#!/bin/sh
#
# MartiniB #
#
# 2012.09.16 - WebIF/plugin.py	# change default value of `Webinterface.http.auth` to True
# 2012.09.16 - WebIF/plugin.py	# bypas autentification for Hosts defined as trusted
# 2012.09.16 - WebIfConfig.py	# Trusted Hosts (View only, edit trough /etc/enigma2/settings)
# 2012.07.25 - GraphMultiEpg.py	# enable localise/translate `Zap`
# 2012.07.21 - ServiceName.py	# fix IP-TV mode
# 2012.04.22 - ServiceName.py	# On / Off   "Add compact SatPos to Service Name"
# 2012.04.22 - /usr/share/enigma2/setup.xml  "Add compact SatPos to Service Name"
# 2012.04.22 - UsageConfig.py	# add option "Add compact SatPos to Service Name" in to `Menu  System  Customize` section
# 2012.04.21 - ServiceScan.py	# increase count in last scanned services list from 10 to 10000
# 2012.04.20 - ChannelSelection.py # select current service when open All Services
# 2012.04.07 - ChannelSelection.py # enable localise/translate `Bouquets` in title(doesnt work, maybe some changes in mo requered)
# 2012.04.07 - ChannelSelection.py # enable localise/translate `Channel selection` in title
# 2012.04.07 - ChannelSelection.py # increase cut lenght to 65 characters
# 2012.04.05 - ChannelSelection.py # cut begining of window title if lenght > 60 characters
# 2012.04.04 - ChannelSelection.py # as window title show last two folders title instead `Channel selection`+ last folder title
# 2012.03.22 - *.py_orig_*	# search for last backup copy when patcer.sh newer than *.py
# 2012.03.22 - ServiceName.py	# fix Folder Titles
# 2012.03.21 - ChannelSelection.py # hide empty NewFound folders
# 2012.03.21 - ChannelSelection.py # show services count only for selected folders
# 2012.03.21 - /usr/share/enigma2/setup.xml  "Show Services Count for Folders"
# 2012.03.21 - UsageConfig.py	# add option "Show Services Count for Folders" in to `Menu  System  Customize` section
# 2012.03.21 - /usr/share/enigma2/setup.xml  "Hide Empty NewFound Folders"
# 2012.03.21 - UsageConfig.py	# add option "Hide Empty NewFound Folders" in to `Menu  System  Customize` section
# 2012.03.20 - ChannelSelection.py # show services count
# 2012.03.19 - ChannelSelection.py # change bouqets path separator '/' to '  '
# 2012.02.14 - Web/ServicesReload # add self.eDVBDB.removeServices()
# 2012.01.26 - /usr/share/enigma2/setup.xml  "AutoHide Infobar"
# 2012.01.26 - UsageConfig.py	# add option "AutoHide Infobar" in to `Menu  System  Customize` section
# 2011.11.05 - AudioSelection.py# adopted for swaped way
# 2011.10.19 - encoding.conf	# add lines for Baltcom Riga_MMDS(cable tv)
# 2011.10.18 - crontabs		# add rdate
# 2011.07.30 - opkg.conf	# remove paths to */media/* folders
# 2011.07.19 - AudioSelection.py# swap Subtitles<->AudioTracks(Yellow button description)
# 2011.07.07 - *.py_orig_*	# remove backup copy if md5 checksum same as previous
# 2011.04.04 - E2 config	# set ParentalControl default values 1111
# 2011.02.22 - E2 config	# set useTransponderTime=false if rdate installed
# 2011.02.22 - E2 config	# set WebIF autentification On
# 2010.10.27 - ChannelSelection.py # start Set_Audio_Language_by_Priority.sh on service zap
# 2010.07.14 - E2 config	# add more parameters to E2 config(if not present)
# 2010.06.15 - EventName.py	# move EPG's ShortDescription text to ExtendedDescription when Extended is empty
# 2010.06.13 - ServiceName.py	# fix File Play mode
# 2010.04.22 - E2 config	# add parameter "show_event_progress_in_servicelist" to E2 config(if not present)
# 2010.04.22 - ServiceName.py	# fix DVD mode
# 2010.04.17 - EventName.py	# add EPG FULL_DESCRIPTION to services list
# 2010.04.17 - EventName.py	# remove '"' if EPG EventName starts and ends with it
# 2010.04.14 - ServiceName.py	# add orbital position to selected service name
#

cPATH="/usr/lib/enigma2/python/"

pyFilesToPatch="
"Components/UsageConfig.py"
"Components/Converter/EventName.py"
"Components/Converter/ServiceName.py"
"Screens/AudioSelection.py"
"Screens/ChannelSelection.py"
"Plugins/Extensions/GraphMultiEPG/GraphMultiEpg.py"
"Plugins/Extensions/WebInterface/WebComponents/Sources/ServiceListReload.py"
"Plugins/Extensions/WebInterface/WebIfConfig.py"
"Plugins/Extensions/WebInterface/plugin.py"
"Screens/ServiceScan.py"
"

E2Conf="/etc/enigma2/settings"

foo="$0"
shTMP=${foo%.*}".tmp"
shTXT=${foo%.*}".txt"
shDATE=`date -r $0 +%Y%m%d`

n="\n"
t="\t"
t2="\t\t"
t3="\t\t\t"
t4="\t\t\t\t"
t5="\t\t\t\t\t"
t6="\t\t\t\t\t\t"
t7="\t\t\t\t\t\t\t"
AND="\&"

[ ! -e "$shTXT" ] && echo -e $t"MD5-ControlSum"$t3"Date-Time"$t"Patched-File">"$shTXT"

comment0="\#"
comment1="\# -"
comment2="\# +"

AddSedLine () {
	if [ "$newstr" = "" ]; then
		echo s?"$oldstr"?"$comment1"\&?"$SedOption">>"$cPATH$cFILE".sed
	else
		echo s?"$oldstr"?"$comment1"\&"$n$comment2$n$newstr$n$comment2"\ END?"$SedOption">>"$cPATH$cFILE".sed
	fi
	SedOption=""
}

AddSedLineBefore () {
	echo s?"$oldstr"?"$comment2$n$newstr$n$comment2"\ END"$n"\&?"$SedOption">>"$cPATH$cFILE".sed
	SedOption=""
}

AddSedLineAfter () {
	echo s?"$oldstr"?\&"$n$comment2$n$newstr$n$comment2"\ END?"$SedOption">>"$cPATH$cFILE".sed
	SedOption=""
}

DoPatch () {
[ -e "$cPATH$cFILE".sed ] && rm -f "$cPATH$cFILE".sed
case $cFILE in
   "Components/Converter/EventName.py")
	Check=`grep "^[[:space:]]ID\ =\ 3" $cPATH$cFILE`
	if [ "$Check" ]; then
		newstr="$t"FULL_DESCRIPTION\ =\ 3"$n$t"ID\ =\ 4
		oldstr="$t"ID\ =\ 3
		AddSedLine
		Check=`grep "^[[:space:]][[:space:]]elif type == \"ID\":" $cPATH$cFILE`
		if [ "$Check" ]; then
			newstr="$t$t"elif\ type\ ==\ \"FullDescription\":
			newstr="$newstr$n$t3"self.type\ =\ self.FULL_DESCRIPTION
			newstr="$newstr$n$t$t"elif\ type\ ==\ \"ID\"\ :
			oldstr=^"$t$t"elif\ type\ ==\ \"ID\":
			AddSedLine
		fi
		Check=`grep "^[[:space:]][[:space:]][[:space:]]return\ event.getEventName\(\)" $cPATH$cFILE`
		if [ "$Check" ]; then
			newstr="$t3"nstr\ =\ event.getEventName\(\)
			newstr="$newstr$n$t3"if\ nstr[0:1]\ ==\ \'\\\\\"\'\ and\ nstr[-1]\ ==\ \'\\\\\"\':
			newstr="$newstr$n$t4"nstr\ =\ nstr[1:len\(nstr\)-1]
			newstr="$newstr$n$t3"return\ nstr
			oldstr=^"$t3"return\ event.getEventName\(\)
			AddSedLine
		fi
		Check=`grep "^[[:space:]][[:space:]][[:space:]]return\ event.getShortDescription\(\)" $cPATH$cFILE`
		if [ "$Check" ]; then
			newstr="$t3"if\ event.getExtendedDescription\(\)\ ==\ \"\":
			newstr="$newstr$n$t4"return\ \"\"
			newstr="$newstr$n$t3"else:
			newstr="$newstr$n$t4"return\ event.getShortDescription\(\)
			oldstr=^"$t3"return\ event.getShortDescription\(\)
			AddSedLine
		fi
		Check=`grep "^[[:space:]][[:space:]][[:space:]]return\ event.getExtendedDescription\(\)" $cPATH$cFILE`
		if [ "$Check" ]; then
			newstr="$t3"if\ event.getExtendedDescription\(\)\ ==\ \"\":
			newstr="$newstr$n$t4"return\ event.getShortDescription\(\)
			newstr="$newstr$n$t3"else:
			newstr="$newstr$n$t4"return\ event.getExtendedDescription\(\)
			oldstr=^"$t3"return\ event.getExtendedDescription\(\)
			AddSedLine
		fi
		Check=`grep "^[[:space:]][[:space:]]elif\ self.type\ ==\ self.ID:"  $cPATH$cFILE`
		if [ "$Check" ]; then
			newstr="$t$t"elif\ self.type\ ==\ self.FULL_DESCRIPTION:
			newstr="$newstr$n$t3"desc\ =\ event.getShortDescription\(\)\ or\ \"\"
			newstr="$newstr$n$t3"if\ desc\ !=\ \"\":
			newstr="$newstr$n$t4"desc\ =\ desc\ +\ \'\\\\n\\\\n\'
			newstr="$newstr$n$t3"desc\ =\ desc\ +\ event.getExtendedDescription\(\)\ or\ \"\"
			newstr="$newstr$n$t3"return\ desc
			newstr="$newstr$n$t$t"elif\ self.type\ ==\ self.ID\ :
			oldstr=^"$t$t"elif\ self.type\ ==\ self.ID:
			AddSedLine
		fi
	fi
   ;;
   "Components/Converter/ServiceName.py")
	if ! grep -qs 'import config' $cPATH$cFILE; then
		oldstr=^class\ ServiceName\(Converter
		newstr=from\ Components\.config\ import\ config
		AddSedLineBefore
	fi
	Check=`grep "^[[:space:]][[:space:]][[:space:]]return\ name\.replace(.*" $cPATH$cFILE`
	if [ "$Check" -a ! `echo "$Check"| grep " + "| sed s/.*\ +\ //` ]; then
		oldstr=^"$t2"if\ self\.type\ ==\ self\.NAME:
		newstr="$t2"orbposstr\ =\ \"\"
		AddSedLineBefore
		newstr="$t4"refstr\ =\ self.getServiceInfoValue\(info,\ iServiceInformation.sServiceref,\ ref\)
		newstr="$newstr$n$t4"if\ len\(refstr\)\ \<\ 10:\ "$comment0"\ no\ info\ in\ DVD\ mode
		newstr="$newstr$n$t5"return\ \"\"
		newstr="$newstr$n$t4"else:
		newstr="$newstr$n$t5"refstr\ =\ refstr.split\(\':\'\)
		newstr="$newstr$n$t5"namespace\ =\ int\(refstr\[6\],\ 16\)\ \>\>\ 16
		newstr="$newstr$n$t5"namespace_u\ =\ namespace
		newstr="$newstr$n$t3"else:
		newstr="$newstr$n$t4"namespace\ =\ service.getData\(4\)\ \>\>\ 16
		newstr="$newstr$n$t4"namespace_u\ =\ service.getUnsignedData\(4\)\ \>\>\ 16
		newstr="$newstr$n$t4"if\ 0\ ==\ service\.getData\(1\)\ +\ service\.getData\(2\)\ +\ service\.getData\(3\):\ "$comment0"Folder\ Title
		newstr="$newstr$n$t5"orbposstr\ =\ \"-\"
		newstr="$newstr$n$t3"if\ namespace_u\ \<\ 0:
		newstr="$newstr$n$t4"namespace\ +=\ 3600
		newstr="$newstr$n$t3"if\ not\ config.usage.add_compact_satpos_to_service_name.value:
		newstr="$newstr$n$t4"orbposstr\ =\ \"\"
		newstr="$newstr$n$t3"elif\ namespace_u\ ==\ 0\ or\ orbposstr\ ==\ \"-\":\ "$comment0"File\ play\ mode
		newstr="$newstr$n$t4"orbposstr\ =\ \"\"
		newstr="$newstr$n$t3"elif\ namespace_u\ ==\ 0xFFFF:\ "$comment0"Cable
		newstr="$newstr$n$t4"orbposstr\ =\ \"\"\ "$comment0"\"\ \(dvb-c\)\"
		newstr="$newstr$n$t3"elif\ namespace_u\ ==\ 0xEEEE:\ "$comment0"Terrestrial
		newstr="$newstr$n$t4"orbposstr\ =\ \"\"\ "$comment0"\"\ \(dvb-t\)\"
		newstr="$newstr$n$t3"elif\ namespace_u\ ==\ 0xAAA1:\ "$comment0"IPTV
		newstr="$newstr$n$t4"orbposstr\ =\ \"\"\ "$comment0"\"\ \(ip-tv\)\"
		newstr="$newstr$n$t3"else:
		newstr="$newstr$n$t4"if\ namespace\ \>\ 1800:
		newstr="$newstr$n$t5"orbposstr\ =\ \"\ \(%.0f%s\)\"\ %\ \(\(3600\ -\ namespace\ +\ 4\)\ \/\ 10,\ \"W\"\)
		newstr="$newstr$n$t4"else:
		newstr="$newstr$n$t5"orbposstr\ =\ \"\ \(%.0f%s\)\"\ %\ \(\(namespace\ +\ 4\)\ \/\ 10,\ \"E\"\)
		newstr="$newstr$n$t3"return\ name.replace\(\'\\\\xc2\\\\x86\',\ \'\'\).replace\(\'\\\\xc2\\\\x87\',\ \'\'\)\ +\ orbposstr
		oldstr=^"$t3"return\ name\.replace\(.*
		AddSedLine
	fi
   ;;
   "Screens/ChannelSelection.py")
	if ! grep -qs '^[[:space:]][[:space:]][[:space:]]titleStr = _("Channel Selection")' $cPATH$cFILE; then
		oldstr=^"$t3"pos\ =\ titleStr\.find\(\'\)\'\)
		newstr="$t3"titleStr\ =\ _\(\"Channel\ Selection\"\)
		newstr="$newstr$n$t3"if\ self\.mode\ ==\ MODE_TV:
		newstr="$newstr$n$t4"titleStr\ +=\ \"\ \(TV\)\"
		newstr="$newstr$n$t3"else:
		newstr="$newstr$n$t4"titleStr\ +=\ \"\ \(Radio\)\"
		AddSedLineBefore
		oldstr=^"$t4"if\ Len\ \>\ 1:
		newstr="$t4"if\ Len\ \>\ 2:
		newstr="$newstr$n$t5"end2_ref\ =\ self\.servicePath\[Len-2\]
		newstr="$newstr$n$t4"else:
		newstr="$newstr$n$t5"end2_ref\ =\ None
		AddSedLineBefore
		oldstr=^"$t6"titleStr\ +=\ \'\/\.\.\/\'
		newstr="$t6"if\ end2_ref\ is\ not\ None:
		newstr="$newstr$n$t7"nameStr\ =\ self\.getServiceName\(end2_ref\)
		newstr="$newstr$n$t7"titleStr\ =\ nameStr\ +\ \'\ \\\\xbb\ \'
		newstr="$newstr$n$t6"else:
		newstr="$newstr$n$t7"titleStr\ +=\ \'\ \\\\xbb\.\.\\\\xbb\ \'
		AddSedLine
		oldstr=^"$t6"titleStr\ +=\ \'\/\'
		newstr="$t6"titleStr\ +=\ \'\ \\\\xbb\ \'
		AddSedLine
		oldstr=^"$t5"nameStr\ =\ self\.getServiceName\(end_ref\)
		newstr="$t5"if\ len\(nameStr\)\ \>\ 60:
		newstr="$newstr$n$t6"titleStr\ =\ \"\"
		AddSedLineAfter
		oldstr=^"$t4"self\.setTitle\(titleStr\)
		newstr="$t4"if\ len\(titleStr\)\ \>\ 65:
		newstr="$newstr$n$t5"titleStr\ =\ \"%s%s\"\ %\(\'\.\.\',\ titleStr\[-64:\]\)
		AddSedLineBefore
	fi
#		str = self.removeModeStr(ServiceReference(ref).getServiceName())
#		# OpenPLI's version
#		if 'User - bouquets' in str:
#			return _("User - bouquets")
	if ! grep -qs '^[[:space:]][[:space:]][[:space:]]return _("Bouquets")' $cPATH$cFILE; then
		oldstr=^"$t2"str\ =\ self\.removeModeStr\(ServiceReference\(ref\)\.getServiceName\(\)\)
		newstr="$t2"if\ \'Bouquet\'\ in\ str:
		newstr="$newstr$n$t3"return\ _\(\"Bouquets\"\)
		AddSedLineAfter
	fi
	if ! grep -qs '^[[:space:]][[:space:]][[:space:]][[:space:]][[:space:]]self.setCurrentSelection(self.session.nav.getCurrentlyPlayingServiceR' $cPATH$cFILE; then
		oldstr=^"$t5"self\.enterPath\(ref\)
		newstr="$t5"self\.setCurrentSelection\(self\.session\.nav\.getCurrentlyPlayingServiceReference\(\)\)
		AddSedLineAfter

	fi
	if ! grep -qs '^[[:space:]][[:space:]][[:space:]]self.servicelist.setCurrent(service)' $cPATH$cFILE; then
		oldstr=^"$t2"self\.servicelist\.setCurrent\(service\)
		newstr="$t2"if\ service:
		newstr="$newstr$n$t3"self\.servicelist\.setCurrent\(service\)
		AddSedLine

	fi

	if [ -e /usr/script/Set_Audio_Language_by_Priority.sh ]; then
	  Check=`grep '^[[:space:]][[:space:]][[:space:]]os.system("/usr/script/Set_Audio_Language.*' $cPATH$cFILE`
	  if [ ! "$Check" ]; then
		Check=`grep "^[[:space:]][[:space:]][[:space:]]self.addToHistory(nref)" $cPATH$cFILE`
		if [ "$Check" ]; then
			oldstr=^"$t3"self\.addToHistory\(nref\)
			newstr="$t3"import\ os
			newstr="$newstr$n$t3"os\.system\(\"\/usr\/script\/Set_Audio_Language_by_Priority\.sh\ ExecuteOnce\ $AND\"\)
			AddSedLineAfter
		fi
	  fi
	fi
	if ! grep -qs getServicesCount $cPATH$cFILE; then
	  if grep -qs "^[[:space:]]def showSatellites(self)" $cPATH$cFILE; then
		oldstr=^"$t"def\ showSatellites\(self\):
		newstr="$t"def\ getServicesCount\(self\,\ root_ref\):
		newstr="$newstr$n$t2"count\ =\ 0
		newstr="$newstr$n$t2"serviceHandler\ =\ eServiceCenter\.getInstance\(\)
		newstr="$newstr$n$t2"list\ =\ serviceHandler\.list\(root_ref\)
		newstr="$newstr$n$t2"if\ list\ is\ not\ None:
		newstr="$newstr$n$t3"while\ True:
		newstr="$newstr$n$t4"s\ =\ list\.getNext\(\)
		newstr="$newstr$n$t4"if\ not\ s\.valid\(\):\ break
		newstr="$newstr$n$t4"count\ +=\ 1
		newstr="$newstr$n$t2"return\ count
		AddSedLineBefore
		if ! grep -qs "self.getServicesCount(service" $cPATH$cFILE; then
			if grep -qs "^[[:space:]][[:space:]][[:space:]][[:space:]][[:space:]][[:space:]][[:space:]]if\ service\.getPath\(\)" $cPATH$cFILE; then
				tx="$t5$t2"
			elif grep -qs "^[[:space:]][[:space:]][[:space:]][[:space:]][[:space:]][[:space:]][[:space:]][[:space:]]if\ service\.getPath\(\)" $cPATH$cFILE; then
				tx="$t5$t3"
			elif grep -qs "^[[:space:]][[:space:]][[:space:]][[:space:]][[:space:]][[:space:]][[:space:]][[:space:]][[:space:]]if\ service\.getPath\(\)" $cPATH$cFILE; then
				tx="$t5$t4"
			fi
			oldstr=^"$tx"if\ service\.getPath\(\)
			newstr="$tx"skip\ =\ 0"$n$tx"cntstr\ =\ \"\"
			AddSedLineBefore
			oldstr=^"$tx$t"service_type.*\"New\"
			newstr="$tx$t"if\ \"\.\.New\"\ in\ config\.usage\.show_services_count_for_folders\.value\ or\ config\.usage\.hide_empty_newfound_folders\.value:
			newstr="$newstr$n$tx$t2"cnt\ =\ self\.getServicesCount\(service\)
			newstr="$newstr$n$tx$t2"if\ cnt\ ==\ 0\ and\ config\.usage\.hide_empty_newfound_folders\.value:
			newstr="$newstr$n$tx$t3"skip\ =\ 1
			newstr="$newstr$n$tx$t2"else:
			newstr="$newstr$n$tx$t3"cntstr\ =\ \"\ \(\%d\)\"\%\(cnt\)
			AddSedLineBefore
			oldstr=^"$tx$t"service_type.*\"Services\".*FTA
			newstr="$tx$t"if\ \"\.\.FTA\"\ in\ config\.usage\.show_services_count_for_folders\.value:
			newstr="$newstr$n$tx$t2"cntstr\ =\ \"\ \(\%d\)\"\%\(self\.getServicesCount\(service\)\)
			AddSedLineBefore
			oldstr=^"$tx$t"service_type.*\"Services\"\)\$
			newstr="$tx$t"if\ \"\.\.Simple\"\ in\ config\.usage\.show_services_count_for_folders\.value:
			newstr="$newstr$n$tx$t2"cntstr\ =\ \"\ \(\%d\)\"\%\(self\.getServicesCount\(service\)\)
			AddSedLineBefore
			oldstr=^"$tx"service\.setName\(.*service_name.*service_type
			newstr=""
			AddSedLine
			oldstr=^"$tx"self\.servicelist\.addService\(service\)
			newstr="$tx"if\ not\ skip:
			newstr="$newstr$n$tx$t"service\.setName\(\"\%s\ -\ \%s\%s\"\ \%\(service_name\,\ service_type\,\ cntstr\)\)
			newstr="$newstr$n$t"\&
			AddSedLine
		fi
	  fi
	fi
   ;;
   "Screens/AudioSelection.py")
	if grep -qs "^[[:space:]][[:space:]]choicelist\ =\ \[(PAGE_AUDIO,_(\"audio\ tracks" $cPATH$cFILE; then
		oldstr=^"$t2"choicelist\ =\ .*\(PAGE_AUDIO\,_\(\"audio.*
		newstr="$t2"choicelist\ =\ \[\(PAGE_AUDIO\,_\(\"switch\ to\ Subtitles\"\)\)\,\ \(PAGE_SUBTITLES\,_\(\"switch\ to\ Audiotracks\"\)\)\]
		AddSedLine
	elif grep -qs "^[[:space:]][[:space:]]choicelist\ =\ \[(PAGE_AUDIO,_(\"Subtitles" $cPATH$cFILE; then
		oldstr=^"$t2"choicelist\ =\ .*\(PAGE_AUDIO\,_\(\"Subtitles.*
		newstr="$t2"choicelist\ =\ \[\(PAGE_AUDIO\,_\(\"switch\ to\ Subtitles\"\)\)\,\ \(PAGE_SUBTITLES\,_\(\"switch\ to\ Audiotracks\"\)\)\]
		AddSedLine
	fi
   ;;
   "Components/UsageConfig.py")
	if ! grep -qs "config.usage.toggle_show_close_automatically" $cPATH$cFILE; then
		oldstr=^"$t"config\.usage\ =\ ConfigSubsection\(\)\;
		newstr="$t"config\.usage\.toggle_show_close_automatically\ =\ ConfigYesNo\(default\ =\ False\)
		AddSedLineAfter
	fi
	if ! grep -qs "show_services_count_for_folders" $cPATH$cFILE; then
		oldstr=^"$t"config\.usage\.blinking_display_clock_during_recording\ =\ ConfigYesNo
		newstr="$t"config\.usage\.show_services_count_for_folders\ =\ ConfigSet\(default=\[\"..New\"\]\,\ choices\ =\ \[\"..New\"\,\ \"..FTA\"\,\ \"..HD\"\,\ \"..Simple\"\]\)
		newstr="$newstr$n$n$t"config\.usage\.hide_empty_newfound_folders\ =\ ConfigYesNo\(default\ =\ True\)
		AddSedLineBefore
	fi
	if ! grep -qs "config.usage.add_compact_satpos_to_service_name" $cPATH$cFILE; then
		oldstr=^"$t"config\.usage\ =\ ConfigSubsection\(\)\;
		newstr="$t"config\.usage\.add_compact_satpos_to_service_name\ =\ ConfigYesNo\(default\ =\ True\)
		AddSedLineAfter
	fi
   ;;
   "Plugins/Extensions/WebInterface/WebComponents/Sources/ServiceListReload.py")
	Check=`grep '^[[:space:]][[:space:]]self.eDVBDB.removeServices.*' $cPATH$cFILE`
	if [ ! "$Check" ]; then
		oldstr=^"$t2"self\.eDVBDB\.reloadServicelist\(\)
		newstr="$t2"self\.eDVBDB\.removeServices\(\)
		AddSedLineBefore
	fi
   ;;
   "Screens/ServiceScan.py")
	if ! grep -qs '^[[:space:]][[:space:]]self["servicelist"] = FIFOList(len=10000)' $cPATH$cFILE; then
		oldstr=^"$t2"self\.*servicelist\.*FIFOList\.*
		newstr="$t2"self\[\"servicelist\"\]\ =\ FIFOList\(len=10000\)
		AddSedLine
	fi
   ;;
   "Plugins/Extensions/GraphMultiEPG/GraphMultiEpg.py")
	if ! grep -qs '^[[:space:]][[:space:]][[:space:]][[:space:]]self["key_red"].setText(_("Zap"))' $cPATH$cFILE; then
		oldstr=^"$t4"self\.*setText\(\"Zap\"\)
		newstr="$t4"self\[\"key_red\"\]\.setText\(_\(\"Zap\"\)\)
		AddSedLine
	fi
   ;;
   "Plugins/Extensions/WebInterface/plugin.py")
	if ! grep -qs "config.plugins.Webinterface.trustedhosts" $cPATH$cFILE; then
		oldstr=^from\ socket\ import\ gethostname\ as.*
		newstr=from\ socket\ import\ gethostname\ as\ socket_gethostname\,\ gethostbyname
		newstr="$newstr$n"import\ re
		AddSedLine
		oldstr=^config\.plugins\.Webinterface\.streamauth.*
		newstr=config\.plugins\.Webinterface\.trustedhosts\ =\ ConfigText\(default=\"localhost\;192\.168\.\;10\.0\.0\.\;10\.0\.10\.\"\)
		AddSedLineAfter
		oldstr="$t2"host\ =\ request\.getHost\(\)\.host
		newstr="$t2"if\ config\.plugins\.Webinterface\.trustedhosts\.value\ \!=\ \"\":
		newstr="$newstr$n$t3"strReport\ =\ \"\[WebInterface\.plugin\.isAuthenticated\]\ bypassing\ authcheck\,\ host\ \'\%s\'\ defined\ as\ trusted\"\ \%host
		newstr="$newstr$n$t3"th_list\ =\ config\.plugins\.Webinterface\.trustedhosts\.value\.split\(\'\;\'\)
		newstr="$newstr$n$t3"if\ host\ in\ th_list:
		newstr="$newstr$n$t4"print\ strReport
		newstr="$newstr$n$t4"return\ True
		newstr="$newstr$n$t3"else:
		newstr="$newstr$n$t4"th_textual\ =\ \[\]
		newstr="$newstr$n$t4"for\ th\ in\ th_list:
		newstr="$newstr$n$t5"if\ th\ ==\ \"\":
		newstr="$newstr$n$t6"skip_empty\ =\ \"\"
		newstr="$newstr$n$t5"elif\ host\.find\(th\)\ ==\ 0:
		newstr="$newstr$n$t6"print\ strReport
		newstr="$newstr$n$t6"return\ True
		newstr="$newstr$n$t5"elif\ re\.sub\(\'\[0-9\.\]\'\,\ \'\'\,\ th\)\ \!=\ \"\":
		newstr="$newstr$n$t6"th_textual\.append\(th\)
		newstr="$newstr$n$t4"for\ th\ in\ th_textual:
		newstr="$newstr$n$t5"if\ host\ ==\ gethostbyname\(th\):
		newstr="$newstr$n$t6"print\ strReport
		newstr="$newstr$n$t6"return\ True
		AddSedLineAfter
	fi
	if ! grep -qs "Webinterface.http.auth = ConfigYesNo(default=True" $cPATH$cFILE; then
		oldstr=config\.plugins\.Webinterface\.http\.auth\ =\ ConfigYesNo\(default=False\)
		newstr=config\.plugins\.Webinterface\.http\.auth\ =\ ConfigYesNo\(default=True\)
		AddSedLine
	fi
   ;;
   "Plugins/Extensions/WebInterface/WebIfConfig.py")
	if ! grep -qs "config.plugins.Webinterface.trustedhosts" $cPATH$cFILE; then
		oldstr=\"\)\,\ config\.plugins\.Webinterface\.streamauth\)\)
		newstr="$t2"list\.append\(getConfigListEntry\(_\(\"Trusted\ Hosts\"\)\,\ config\.plugins\.Webinterface\.trustedhosts\)\)
		AddSedLineAfter
	fi
   ;;
esac

if [ -e "$cPATH$cFILE".sed ]; then
	echo patching $cPATH$cFILE
	sed -f "$cPATH$cFILE".sed "$cPATH$cFILE">"$cPATH$cFILE".tmp
	if [ -s "$cPATH$cFILE".tmp ]; then
		mv "$cPATH$cFILE".tmp "$cPATH$cFILE"
	else
		echo ErRoR - Zero len "$cPATH$cFILE".tmp
	fi
fi
}

UpdateMD5list () {
	MD5_CRNT=`md5sum $cPATH$cFILE| awk {'print $1'}`
	if grep -qs " $cFILE " $shTXT; then
		rm -f "$shTMP"
		sed s#.*" $cFILE ".*## $shTXT| sed '/^$/d'>"$shTMP"
		mv "$shTMP" "$shTXT"
	fi
	echo "$MD5_CRNT "`date +%Y.%m.%d.\ %H:%M:%S`" $cFILE ">>"$shTXT"
}

for cFILE in $pyFilesToPatch; do
  if [ -e $cPATH$cFILE ]; then
	MD5_OLD=`grep " $cFILE " "$shTXT"| awk {'print $1'}`
	MD5_CRNT=`md5sum $cPATH$cFILE| awk {'print $1'}`
	DoPatch=0
	if [ ! "$MD5_OLD" = "$MD5_CRNT" ]; then
		DoPatch=1
	else
		LastBcFile=""
		for bcFile in $cPATH$cFILE"_orig_"*; do
			[ -e "$bcFile" ] && LastBcFile="$bcFile"
		done
		if [ "$LastBcFile" ]; then
			fDATE=`date -r $cPATH$cFILE +%Y%m%d`
			if [ "$shDATE" -gt "$fDATE" ]; then
				txDATE=`grep " $cFILE " "$shTXT"| awk {'print $2'}| sed 's?\.??g'`
				[ "$fDATE" = "$txDATE" ] && cp $LastBcFile $cPATH$cFILE && DoPatch=1
			fi
		fi
	fi
	if [ "$DoPatch" = "1" ]; then
		[ ! -e $cPATH$cFILE"_orig_"`date +%y%m%d` ] && cp $cPATH$cFILE $cPATH$cFILE"_orig_"`date +%y%m%d`
		MD5_OLD=00
		for bcFile in $cPATH$cFILE"_orig_"*; do
			MD5_CRNT=`md5sum $bcFile| awk {'print $1'}`
			[ "$MD5_OLD" = "$MD5_CRNT" ] && rm -rf "$bcFile" || MD5_OLD="$MD5_CRNT"
		done
		DoPatch
		UpdateMD5list
	fi
  fi
done


#
# add option "AutoHide Infobar"
# add option "Show Services Count for Folders"
# add option "Hide Empty NewFound Folders"
# add option "Add compact SatPos to Service Name"
#
#	into `Menu  System  Customize` section
#
cFILE=/usr/share/enigma2/setup.xml
if [ -e "$cFILE" ]; then
  for i in `seq 1 4`; do
	case $i in
	1) strOPT="toggle_show_close_automatically"	strDESCR="Auto Hide manual activated Infobar"
		afterOPTION="infobar_timeout"	beforeOPTION="";;
	2) strOPT="show_services_count_for_folders"	strDESCR="Show Services Count for Folders"
		beforeOPTION="show_infobar_on_zap" afterOPTION="";;
	3) strOPT="hide_empty_newfound_folders"		strDESCR="Hide Empty NewFound folders";;
	4) strOPT="add_compact_satpos_to_service_name"	strDESCR="Add compact SatPos to Service Name";;
	esac
	if ! grep -qs "config\.usage\.$strOPT" "$cFILE"; then
		if [ "$afterOPTION" ]; then
			sed s?^[[:space:]][[:space:]][[:space:]]\<item.*"$afterOPTION".*?\&"$n$t3"\<item\ level=\"0\"\ text=\""$strDESCR"\"\>config\.usage\."$strOPT"\<\/item\>? $cFILE>"$cFILE".tmp
		else
			sed s?^[[:space:]][[:space:]][[:space:]]\<item.*"$beforeOPTION".*?"$t3"\<item\ level=\"0\"\ text=\""$strDESCR"\"\>config\.usage\."$strOPT"\<\/item\>"$n"\&? $cFILE>"$cFILE".tmp
		fi
		[ -s "$cFILE".tmp ] && mv "$cFILE".tmp "$cFILE"
	fi
  done
fi

#
# Enigma2 config remove parameters
#
strParam="config.usage.quickzap_bouquet_change=true"
if grep -qs "$strParam" "$E2Conf"; then
	sed s#$strParam## $E2Conf| sed '/^$/d'>"$E2Conf".tmp
	[ -s "$E2Conf".tmp ] && mv "$E2Conf".tmp "$E2Conf"
fi
strParam="config.usage.on_long_powerpress=shutdown"
if grep -qs "$strParam" "$E2Conf"; then
	sed s#$strParam## $E2Conf| sed '/^$/d'>"$E2Conf".tmp
	[ -s "$E2Conf".tmp ] && mv "$E2Conf".tmp "$E2Conf"
fi

#
# Enigma2 config add parameters
#
for i in `seq 1 44`; do
  case $i in
	1) strDefVal="true" ifPackageInstalled=""
		strParam="config.usage.show_event_progress_in_servicelist=";;
	2)	strParam="config.usage.blinking_display_clock_during_recording=";;
	3)	strParam="config.usage.e1like_radio_mode=";;
	4)	strParam="config.usage.multibouquet=";;
	5)	strParam="config.plugins.catext.skin=";;
	6)	strParam="config.plugins.nextevent.skin=";;
	7)	strParam="config.inputDevices.event0.enabled=";;
	8)	strParam="config.inputDevices.event2.enabled=";;
	9)	strParam="config.plugins.Webinterface.http.auth=";;
	10)	strParam="config.plugins.Webinterface.interfaces.0.useauth=";;
	11)	strParam="config.plugins.Webinterface.autowritetimer=";;
	12)	strParam="config.plugins.Webinterface.includemedia=";;
	13)	strParam="config.ParentalControl.configured=";;
	14)	strParam="config.ParentalControl.servicepinactive=";;

	15)	strParam="config.plugins.Webinterface.interfacecount=" strDefVal="2";;
	16)	strParam="config.plugins.Webinterface.interfaces.1.port=" strDefVal="81";;
	17)	strParam="config.plugins.Webinterface.interfaces.1.address=" strDefVal="127.0.0.1";;
	18)	strParam="config.plugins.crashlogautosubmit.sendmail=" strDefVal="send_never";;
	19)	strParam="config.plugins.Quickbutton.red_b=" strDefVal="Single EPG";;
	20)	strParam="config.plugins.Quickbutton.green=" strDefVal="switch 4:3 content display";;
	21)	strParam="config.plugins.Quickbutton.yellow=" strDefVal="Script Executer";;
	22)	strParam="config.plugins.Quickbutton.blue=" strDefVal="Newnigma2 Services";;
	23)	strParam="config.audio.LanguagePriority=" strDefVal="Latvian#Russian#rus#English#englisch#engl#orj#dos#ORY#orig#org#Tonoption 2#Undetermined#";;
	24)	strParam="config.plugins.installer.check_update_notifier=" strDefVal="-1";;
	25)	strParam="config.inputDevices.event0.delay=" strDefVal="400";;
	26)	strParam="config.inputDevices.event0.repeat=" strDefVal="40";;
	27)	strParam="config.inputDevices.event0.name=" strDefVal="dreambox remote control (native)";;
	28)	strParam="config.inputDevices.event2.delay=" strDefVal="400";;
	29)	strParam="config.inputDevices.event2.repeat=" strDefVal="40";;
	30)	strParam="config.inputDevices.event2.name=" strDefVal="dreambox advanced remote control (native)";;
	31)	strParam="config.ParentalControl.servicepin.0=" strDefVal="1111";;
	32)	strParam="config.ParentalControl.storeservicepin=" strDefVal="30";;
	33)	strParam="config.SleepTimer.ask=" strDefVal="false";;
	34)	strParam="config.SleepTimer.action=" strDefVal="standby";;


	35) strDefVal="Summary"
		strParam="config.plugins.piconlcd.standbylcdtype=";;
	36)	strParam="config.plugins.piconlcd.lcdtype=";;

	37) strDefVal="false"
		strParam="config.plugins.ca.ecminfo=";;
	38)	strParam="config.plugins.installer.check_update_on_boot=";;
	39)	strParam="config.usage.toggle_show_close_automatically=";;
	40)	strParam="config.plugins.Webinterface.interfaces.1.useauth=";;
	41)	strParam="config.plugins.Webinterface.https.enabled=";;
	42)	strParam="config.usage.quickzap_bouquet_change=";;
	43)	strParam="config.plugins.sleeptimermenu.showinextensionsmenu=";;

	44) #ifPackageInstalled="*-rdate"
		ifFile1IsFound=/etc/init.d/rdate
		ifFile2IsFound=/cron/tabs/root
		strParam="config.misc.useTransponderTime=";;
  esac
  if ! grep -qs "$strParam" "$E2Conf"; then
	if [ "$ifPackageInstalled" = "" ] || [ -e "$ifFile1IsFound" -a -e "$ifFile1IsFound" ] || [ `opkg list-installed "$ifPackageInstalled"| awk {'print $1'}` ]; then
		echo "$strParam$strDefVal">>"$E2Conf"
	fi
  fi
done

#
# OPKG config
#
OpkgCFG=/etc/opkg/opkg.conf
TmpSH="/tmp/remove_media_from_opkg_conf.sh"
if grep -qs /media/net/ "$OpkgCFG"; then
	echo "#!/bin/sh
#
	sleep 120
	sed s#.*\ \/media\/.*## $OpkgCFG| sed '/./,/^$/!d'>$OpkgCFG.tmp
	[ -s $OpkgCFG.tmp ] && mv $OpkgCFG.tmp $OpkgCFG
	rm -rf $TmpSH">"$TmpSH"
	chmod 755 "$TmpSH"
	"$TmpSH" &
fi

#
# add rdate to cron
#
if [ -e /etc/init.d/rdate -a -e /cron/tabs ] && ! grep -qs rdate /cron/tabs/root; then
	echo -e 57$t*$t*$t*$t*$t/etc/init.d/rdate start>>/cron/tabs/root
fi

#
# add lines to encoding.conf
#
cFILE=/usr/share/enigma2/encoding.conf
if [ -e "$cFILE" ] && grep -qs terrestrial= "$E2Conf" && ! grep -qs " Baltcom Riga" "$cFILE"; then
	echo "#
# Baltcom Riga_MMDS(Cable Tv)
01 1238 ISO8859-13 # eeee0000:0001:04d6 t 426000000:0:2:0:2:1:1:0:0:0
02 1238 ISO8859-13 # eeee0000:0002:04d6 t 442000000:0:2:0:2:1:1:0:0:0
03 1238 ISO8859-13 # eeee0000:0003:04d6 t 298000000:0:2:0:2:1:1:0:0:0
04 1238 ISO8859-13 # eeee0000:0004:04d6 t 418000000:0:2:0:2:1:1:0:0:0
05 1238 ISO8859-13 # eeee0000:0005:04d6 t 434000000:0:2:0:2:1:1:0:0:0
06 1238 ISO8859-13 # eeee0000:0006:04d6 t 306000000:0:2:0:2:1:1:0:0:0
07 1238 ISO8859-13 # eeee0000:0007:04d6 t 410000000:0:2:0:2:1:1:0:0:0
08 1238 ISO8859-13 # eeee0000:0008:04d6 t 314000000:0:2:0:2:1:1:0:0:0 lv ok
18 1238 ISO8859-13 # eeee0000:0012:04d6 t 370000000:0:2:0:2:1:1:0:0:0
19 1238 ISO8859-13 # eeee0000:0013:04d6 t 378000000:0:2:0:2:1:1:0:0:0 lv ok
20 1238 ISO8859-13 # eeee0000:0014:04d6 t 330000000:0:2:0:2:1:1:0:0:0
21 1238 ISO8859-13 # eeee0000:0015:04d6 t 394000000:0:2:0:2:1:1:0:0:0 lv ok
22 1238 ISO8859-13 # eeee0000:0016:04d6 t 402000000:0:2:0:2:1:1:0:0:0
23 1238 ISO8859-13 # eeee0000:0017:04d6 t 482000000:0:2:0:2:1:1:0:0:0
25 1238 ISO8859-13 # eeee0000:0019:04d6 t 450000000:0:2:0:2:1:1:0:0:0 lt nok(tryed also 4 15 10 1)
26 1238 ISO8859-13 # eeee0000:001a:04d6 t 386000000:0:2:0:2:1:1:0:0:0">>"$cFILE"

fi

exit 0    
